(herald "IKEv1 Public-Key" (algebra diffie-hellman) (bound 15))

(comment "CPSA 3.4.0")
(comment "All input read from IKEv1_quick_nopfs.scm")
(comment "Strand count bounded at 15")

(defprotocol quick diffie-hellman
  (defrole init
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (send
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (recv
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (send
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))
    (uniq-orig ni mid))
  (defrole resp
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (recv
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (send
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (recv
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I))))
      (send "blab"))
    (uniq-orig nr))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton quick
  (vars (lst ni nr mid algo text) (I R name))
  (defstrand init 3 (ni ni) (nr nr) (mid mid) (lst lst) (algo algo)
    (I I) (R R))
  (non-orig (ltk I R) (ltk R I))
  (uniq-orig ni mid)
  (traces
    ((send
       (cat I R mid
         (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
         (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (recv
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (send
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))))

(defprotocol quick diffie-hellman
  (defrole init
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (send
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (recv
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (send
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))
    (uniq-orig ni mid))
  (defrole resp
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (recv
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (send
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (recv
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I))))
      (send "blab"))
    (uniq-orig nr))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton quick
  (vars (nr lst algo ni mid text) (I R name))
  (defstrand resp 3 (ni ni) (nr nr) (mid mid) (lst lst) (algo algo)
    (I I) (R R))
  (non-orig (ltk I R) (ltk R I))
  (uniq-orig nr)
  (traces
    ((recv
       (cat I R mid
         (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
         (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (send
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (recv
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))))

(defprotocol quick diffie-hellman
  (defrole init
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (send
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (recv
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (send
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))
    (uniq-orig ni mid))
  (defrole resp
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (recv
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (send
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (recv
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I))))
      (send "blab"))
    (uniq-orig nr))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton quick
  (vars (ni nr mid lst algo text) (I R name))
  (defstrand init 3 (ni ni) (nr nr) (mid mid) (lst lst) (algo algo)
    (I I) (R R))
  (non-orig (ltk I R) (ltk R I))
  (uniq-orig ni mid)
  (goals
    (forall ((iend node) (I R name) (ni nr mid lst algo text))
      (implies
        (and (p "init" 2 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "mid" iend mid)
          (p "init" "lst" iend lst) (p "init" "algo" iend algo)
          (non (ltk R I)) (non (ltk I R)))
        (or
          (exists ((r1 node)) (and (p "resp" 0 r1) (p "resp" "R" r1 R)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 R))))))
    (forall ((iend node) (I R name) (ni nr mid lst algo text))
      (implies
        (and (p "init" 2 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "mid" iend mid)
          (p "init" "lst" iend lst) (p "init" "algo" iend algo)
          (non (ltk R I)) (non (ltk I R)))
        (or
          (exists ((r1 node))
            (and (p "resp" 0 r1) (p "resp" "R" r1 R)
              (p "resp" "I" r1 I)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 R)
              (p "init" "R" i1 I))))))
    (forall ((iend node) (I R name) (ni nr mid lst algo text))
      (implies
        (and (p "init" 2 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "mid" iend mid)
          (p "init" "lst" iend lst) (p "init" "algo" iend algo)
          (non (ltk R I)) (non (ltk I R)))
        (exists ((r1 node))
          (and (p "resp" 0 r1) (p "resp" "R" r1 R)
            (p "resp" "I" r1 I)))))
    (forall ((iend node) (I R name) (ni nr mid lst algo text))
      (implies
        (and (p "init" 2 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "mid" iend mid)
          (p "init" "lst" iend lst) (p "init" "algo" iend algo)
          (non (ltk R I)) (non (ltk I R)))
        (exists ((r1 node))
          (and (p "resp" 0 r1) (p "resp" "R" r1 R) (p "resp" "I" r1 I)
            (p "resp" "ni" r1 ni) (p "resp" "nr" r1 nr)
            (p "resp" "mid" r1 mid) (p "resp" "lst" r1 lst)
            (p "resp" "algo" r1 algo))))))
  (traces
    ((send
       (cat I R mid
         (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
         (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (recv
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (send
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))))

(defprotocol quick diffie-hellman
  (defrole init
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (send
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (recv
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (send
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))
    (uniq-orig ni mid))
  (defrole resp
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (recv
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (send
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (recv
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I))))
      (send "blab"))
    (uniq-orig nr))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton quick
  (vars (ni nr mid lst algo text) (I R name))
  (defstrand resp 4 (ni ni) (nr nr) (mid mid) (lst lst) (algo algo)
    (I I) (R R))
  (non-orig (ltk I R) (ltk R I))
  (uniq-orig nr)
  (goals
    (forall ((rend node) (I R name) (ni nr mid lst algo text))
      (implies
        (and (p "resp" 3 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "mid" rend mid)
          (p "resp" "lst" rend lst) (p "resp" "algo" rend algo)
          (non (ltk R I)) (non (ltk I R)))
        (or
          (exists ((r1 node)) (and (p "resp" 0 r1) (p "resp" "R" r1 I)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 I))))))
    (forall ((rend node) (I R name) (ni nr mid lst algo text))
      (implies
        (and (p "resp" 3 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "mid" rend mid)
          (p "resp" "lst" rend lst) (p "resp" "algo" rend algo)
          (non (ltk R I)) (non (ltk I R)))
        (or
          (exists ((r1 node))
            (and (p "resp" 0 r1) (p "resp" "R" r1 I)
              (p "resp" "I" r1 R)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 I)
              (p "init" "R" i1 R))))))
    (forall ((rend node) (I R name) (ni nr mid lst algo text))
      (implies
        (and (p "resp" 3 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "mid" rend mid)
          (p "resp" "lst" rend lst) (p "resp" "algo" rend algo)
          (non (ltk R I)) (non (ltk I R)))
        (exists ((i1 node))
          (and (p "init" 0 i1) (p "init" "R" i1 R)
            (p "init" "I" i1 I)))))
    (forall ((rend node) (I R name) (ni nr mid lst algo text))
      (implies
        (and (p "resp" 3 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "mid" rend mid)
          (p "resp" "lst" rend lst) (p "resp" "algo" rend algo)
          (non (ltk R I)) (non (ltk I R)))
        (exists ((i1 node))
          (and (p "init" 0 i1) (p "init" "R" i1 R) (p "init" "I" i1 I)
            (p "init" "ni" i1 ni) (p "init" "nr" i1 nr)
            (p "init" "mid" i1 mid) (p "init" "algo" i1 algo)
            (p "init" "lst" i1 lst))))))
  (comment
    "Responder point of view; agreement / weak agreement / aliveness goals")
  (traces
    ((recv
       (cat I R mid
         (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
         (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (send
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (recv
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I))))
      (send "blab"))))

(defprotocol quick diffie-hellman
  (defrole init
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (send
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (recv
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (send
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))
    (uniq-orig ni mid))
  (defrole resp
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (recv
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (send
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (recv
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I))))
      (send "blab"))
    (uniq-orig nr))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton quick
  (vars (ni nr lst algo mid text) (I R name))
  (defstrand init 3 (ni ni) (nr nr) (mid mid) (lst lst) (algo algo)
    (I I) (R R))
  (deflistener (hash "prf" (ltk I R) lst algo ni nr))
  (non-orig (ltk I R) (ltk R I))
  (uniq-orig ni mid)
  (traces
    ((send
       (cat I R mid
         (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
         (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (recv
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (send
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))
    ((recv (hash "prf" (ltk I R) lst algo ni nr))
      (send (hash "prf" (ltk I R) lst algo ni nr)))))

(defprotocol quick diffie-hellman
  (defrole init
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (send
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (recv
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (send
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))
    (uniq-orig ni mid))
  (defrole resp
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (recv
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (send
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (recv
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I))))
      (send "blab"))
    (uniq-orig nr))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton quick
  (vars (ni nr lst algo mid text) (I R name))
  (defstrand init 3 (ni ni) (nr nr) (mid mid) (lst lst) (algo algo)
    (I I) (R R))
  (deflistener (hash "prf" (ltk R I) lst algo ni nr))
  (non-orig (ltk I R) (ltk R I))
  (uniq-orig ni mid)
  (traces
    ((send
       (cat I R mid
         (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
         (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (recv
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (send
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))
    ((recv (hash "prf" (ltk R I) lst algo ni nr))
      (send (hash "prf" (ltk R I) lst algo ni nr)))))

(defprotocol quick diffie-hellman
  (defrole init
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (send
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (recv
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (send
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))
    (uniq-orig ni mid))
  (defrole resp
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (recv
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (send
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (recv
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I))))
      (send "blab"))
    (uniq-orig nr))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton quick
  (vars (ni nr lst algo mid text) (I R name))
  (defstrand resp 3 (ni ni) (nr nr) (mid mid) (lst lst) (algo algo)
    (I I) (R R))
  (deflistener (hash "prf" (ltk I R) lst algo ni nr))
  (non-orig (ltk I R) (ltk R I))
  (uniq-orig nr)
  (traces
    ((recv
       (cat I R mid
         (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
         (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (send
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (recv
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))
    ((recv (hash "prf" (ltk I R) lst algo ni nr))
      (send (hash "prf" (ltk I R) lst algo ni nr)))))

(defprotocol quick diffie-hellman
  (defrole init
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (send
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (recv
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (send
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))
    (uniq-orig ni mid))
  (defrole resp
    (vars (ni nr mid lst algo text) (I R name))
    (trace
      (recv
        (cat I R mid
          (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
          (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (send
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (recv
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I))))
      (send "blab"))
    (uniq-orig nr))
  (defrole blab-skey
    (vars (key skey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton quick
  (vars (ni nr lst algo mid text) (I R name))
  (defstrand resp 3 (ni ni) (nr nr) (mid mid) (lst lst) (algo algo)
    (I I) (R R))
  (deflistener (hash "prf" (ltk R I) lst algo ni nr))
  (non-orig (ltk I R) (ltk R I))
  (uniq-orig nr)
  (traces
    ((recv
       (cat I R mid
         (enc (hash "prf" (ltk I R) mid lst ni) lst ni (ltk I R))
         (enc (hash "prf" (ltk R I) mid lst ni) lst ni (ltk R I))))
      (send
        (cat R I mid
          (enc (hash "prf" (ltk I R) mid ni algo nr) algo nr (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni algo nr) algo nr
            (ltk R I))))
      (recv
        (cat I R mid (enc (hash "prf" (ltk I R) mid ni nr) (ltk I R))
          (enc (hash "prf" (ltk R I) mid ni nr) (ltk R I)))))
    ((recv (hash "prf" (ltk R I) lst algo ni nr))
      (send (hash "prf" (ltk R I) lst algo ni nr)))))
