(herald "IKEv2 Child" (algebra diffie-hellman) (goals-sat) (bound 8)
  (limit 500))

(comment "CPSA 3.4.0")
(comment "All input read from IKEv2_child.lsp")
(comment "Step count limited to 500")
(comment "Strand count bounded at 8")
(comment "Stop when goals satisfied")

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (i expn) (Gr expr) (I R name))
    (trace
      (send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab"))
    (uniq-orig ni)
    (uniq-gen i)
    (neq ((exp (gen) Gr) (gen)) (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (r expn) (Gi expr) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    (uniq-orig nr)
    (uniq-gen r)
    (neq ((exp (gen) Gi) (gen)))
    (absent (r (exp (gen) Gi)))
    (priority (0 4)))
  (defrole blab-secret
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (ni nr secret ni-0 nr-0 lst3 algo3 text) (I R name) (i expn)
    (Gr expr))
  (defstrand init 2 (ni ni-0) (nr nr-0) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R) (i i) (Gr Gr))
  (deflistener
    (hash "KDF" (hash I R secret "d") (exp (gen) (mul i Gr)) ni nr))
  (neq ((exp (gen) Gr) (gen)) (lst3 algo3))
  (non-orig secret)
  (uniq-gen i)
  (uniq-orig ni-0)
  (traces
    ((send
       (cat I R (enc lst3 ni-0 (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I
          (enc algo3 nr-0 (exp (gen) Gr) (hash R I secret "e")))))
    ((recv
       (hash "KDF" (hash I R secret "d") (exp (gen) (mul i Gr)) ni nr))
      (send
        (hash "KDF" (hash I R secret "d") (exp (gen) (mul i Gr)) ni
          nr)))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (i expn) (Gr expr) (I R name))
    (trace
      (send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab"))
    (uniq-orig ni)
    (uniq-gen i)
    (neq ((exp (gen) Gr) (gen)) (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (r expn) (Gi expr) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    (uniq-orig nr)
    (uniq-gen r)
    (neq ((exp (gen) Gi) (gen)))
    (absent (r (exp (gen) Gi)))
    (priority (0 4)))
  (defrole blab-secret
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (ni nr secret ni-0 nr-0 lst3 algo3 text) (I R name) (i expn)
    (Gr expr))
  (defstrand init 2 (ni ni-0) (nr nr-0) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R) (i i) (Gr Gr))
  (deflistener
    (hash "KDF" (hash R I secret "d") (exp (gen) (mul i Gr)) ni nr))
  (neq ((exp (gen) Gr) (gen)) (lst3 algo3))
  (non-orig secret)
  (uniq-gen i)
  (uniq-orig ni-0)
  (traces
    ((send
       (cat I R (enc lst3 ni-0 (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I
          (enc algo3 nr-0 (exp (gen) Gr) (hash R I secret "e")))))
    ((recv
       (hash "KDF" (hash R I secret "d") (exp (gen) (mul i Gr)) ni nr))
      (send
        (hash "KDF" (hash R I secret "d") (exp (gen) (mul i Gr)) ni
          nr)))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (i expn) (Gr expr) (I R name))
    (trace
      (send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab"))
    (uniq-orig ni)
    (uniq-gen i)
    (neq ((exp (gen) Gr) (gen)) (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (r expn) (Gi expr) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    (uniq-orig nr)
    (uniq-gen r)
    (neq ((exp (gen) Gi) (gen)))
    (absent (r (exp (gen) Gi)))
    (priority (0 4)))
  (defrole blab-secret
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (ni nr secret ni-0 nr-0 lst3 algo3 text) (I R name) (r expn)
    (Gi expr))
  (defstrand resp 2 (ni ni-0) (nr nr-0) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R) (r r) (Gi Gi))
  (deflistener
    (hash "KDF" (hash I R secret "d") (exp (gen) (mul r Gi)) ni nr))
  (priority ((0 0) 4))
  (absent (r (exp (gen) Gi)))
  (neq ((exp (gen) Gi) (gen)))
  (non-orig secret)
  (uniq-gen r)
  (uniq-orig nr-0)
  (traces
    ((recv
       (cat I R (enc lst3 ni-0 (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr-0 (exp (gen) r) (hash R I secret "e")))))
    ((recv
       (hash "KDF" (hash I R secret "d") (exp (gen) (mul r Gi)) ni nr))
      (send
        (hash "KDF" (hash I R secret "d") (exp (gen) (mul r Gi)) ni
          nr)))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (i expn) (Gr expr) (I R name))
    (trace
      (send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab"))
    (uniq-orig ni)
    (uniq-gen i)
    (neq ((exp (gen) Gr) (gen)) (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (r expn) (Gi expr) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    (uniq-orig nr)
    (uniq-gen r)
    (neq ((exp (gen) Gi) (gen)))
    (absent (r (exp (gen) Gi)))
    (priority (0 4)))
  (defrole blab-secret
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (ni nr secret ni-0 nr-0 lst3 algo3 text) (I R name) (r expn)
    (Gi expr))
  (defstrand resp 2 (ni ni-0) (nr nr-0) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R) (r r) (Gi Gi))
  (deflistener
    (hash "KDF" (hash R I secret "d") (exp (gen) (mul r Gi)) ni nr))
  (priority ((0 0) 4))
  (absent (r (exp (gen) Gi)))
  (neq ((exp (gen) Gi) (gen)))
  (non-orig secret)
  (uniq-gen r)
  (uniq-orig nr-0)
  (traces
    ((recv
       (cat I R (enc lst3 ni-0 (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr-0 (exp (gen) r) (hash R I secret "e")))))
    ((recv
       (hash "KDF" (hash R I secret "d") (exp (gen) (mul r Gi)) ni nr))
      (send
        (hash "KDF" (hash R I secret "d") (exp (gen) (mul r Gi)) ni
          nr)))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (i expn) (Gr expr) (I R name))
    (trace
      (send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab"))
    (uniq-orig ni)
    (uniq-gen i)
    (neq ((exp (gen) Gr) (gen)) (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (r expn) (Gi expr) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    (uniq-orig nr)
    (uniq-gen r)
    (neq ((exp (gen) Gi) (gen)))
    (absent (r (exp (gen) Gi)))
    (priority (0 4)))
  (defrole blab-secret
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (ni nr lst3 algo3 secret text) (I R name) (r i expn))
  (defstrand init 3 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R) (i i) (Gr r))
  (defstrand resp 2 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R) (r r) (Gi i))
  (defstrand blab-secret 2 (secret secret))
  (deflistener
    (hash "KDF" (hash I R secret "d") (exp (gen) (mul r i)) ni nr))
  (precedes ((0 0) (1 0)) ((0 2) (2 0)) ((1 1) (0 1)))
  (priority ((1 0) 4))
  (absent (r (exp (gen) i)))
  (ind-zero-in (r (exp (gen) i)))
  (neq ((exp (gen) i) (gen)) ((exp (gen) r) (gen)) (lst3 algo3))
  (uniq-gen r i)
  (uniq-orig ni nr secret)
  (traces
    ((send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e"))))
      (send "blab"))
    ((recv (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    ((recv "blab") (send secret))
    ((recv
       (hash "KDF" (hash I R secret "d") (exp (gen) (mul r i)) ni nr))
      (send
        (hash "KDF" (hash I R secret "d") (exp (gen) (mul r i)) ni
          nr)))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (i expn) (Gr expr) (I R name))
    (trace
      (send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab"))
    (uniq-orig ni)
    (uniq-gen i)
    (neq ((exp (gen) Gr) (gen)) (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (r expn) (Gi expr) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    (uniq-orig nr)
    (uniq-gen r)
    (neq ((exp (gen) Gi) (gen)))
    (absent (r (exp (gen) Gi)))
    (priority (0 4)))
  (defrole blab-secret
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (ni nr lst3 algo3 secret text) (I R name) (r i expn))
  (defstrand init 3 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R) (i i) (Gr r))
  (defstrand resp 2 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R) (r r) (Gi i))
  (defstrand blab-secret 2 (secret secret))
  (deflistener
    (hash "KDF" (hash R I secret "d") (exp (gen) (mul r i)) ni nr))
  (precedes ((0 0) (1 0)) ((0 2) (2 0)) ((1 1) (0 1)))
  (priority ((1 0) 4))
  (absent (r (exp (gen) i)))
  (ind-zero-in (r (exp (gen) i)))
  (neq ((exp (gen) i) (gen)) ((exp (gen) r) (gen)) (lst3 algo3))
  (uniq-gen r i)
  (uniq-orig ni nr secret)
  (traces
    ((send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e"))))
      (send "blab"))
    ((recv (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    ((recv "blab") (send secret))
    ((recv
       (hash "KDF" (hash R I secret "d") (exp (gen) (mul r i)) ni nr))
      (send
        (hash "KDF" (hash R I secret "d") (exp (gen) (mul r i)) ni
          nr)))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (i expn) (Gr expr) (I R name))
    (trace
      (send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab"))
    (uniq-orig ni)
    (uniq-gen i)
    (neq ((exp (gen) Gr) (gen)) (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (r expn) (Gi expr) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    (uniq-orig nr)
    (uniq-gen r)
    (neq ((exp (gen) Gi) (gen)))
    (absent (r (exp (gen) Gi)))
    (priority (0 4)))
  (defrole blab-secret
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (ni nr lst3 algo3 secret text) (I R name) (Gr expr) (i expn))
  (defstrand init 3 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R) (i i) (Gr Gr))
  (defstrand blab-secret 2 (secret secret))
  (deflistener
    (hash "KDF" (hash I R secret "d") (exp (gen) (mul Gr i)) ni nr))
  (precedes ((0 2) (1 0)))
  (neq ((exp (gen) Gr) (gen)) (lst3 algo3))
  (uniq-gen i)
  (uniq-orig ni secret)
  (traces
    ((send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab")) ((recv "blab") (send secret))
    ((recv
       (hash "KDF" (hash I R secret "d") (exp (gen) (mul Gr i)) ni nr))
      (send
        (hash "KDF" (hash I R secret "d") (exp (gen) (mul Gr i)) ni
          nr)))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (i expn) (Gr expr) (I R name))
    (trace
      (send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab"))
    (uniq-orig ni)
    (uniq-gen i)
    (neq ((exp (gen) Gr) (gen)) (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (r expn) (Gi expr) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    (uniq-orig nr)
    (uniq-gen r)
    (neq ((exp (gen) Gi) (gen)))
    (absent (r (exp (gen) Gi)))
    (priority (0 4)))
  (defrole blab-secret
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (ni nr lst3 algo3 secret text) (I R name) (i expn) (Gr expr))
  (defstrand init 3 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R) (i i) (Gr Gr))
  (defstrand blab-secret 2 (secret secret))
  (deflistener
    (hash "KDF" (hash R I secret "d") (exp (gen) (mul i Gr)) ni nr))
  (precedes ((0 2) (1 0)))
  (neq ((exp (gen) Gr) (gen)) (lst3 algo3))
  (uniq-gen i)
  (uniq-orig ni secret)
  (traces
    ((send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab")) ((recv "blab") (send secret))
    ((recv
       (hash "KDF" (hash R I secret "d") (exp (gen) (mul i Gr)) ni nr))
      (send
        (hash "KDF" (hash R I secret "d") (exp (gen) (mul i Gr)) ni
          nr)))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (i expn) (Gr expr) (I R name))
    (trace
      (send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab"))
    (uniq-orig ni)
    (uniq-gen i)
    (neq ((exp (gen) Gr) (gen)) (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (r expn) (Gi expr) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    (uniq-orig nr)
    (uniq-gen r)
    (neq ((exp (gen) Gi) (gen)))
    (absent (r (exp (gen) Gi)))
    (priority (0 4)))
  (defrole blab-secret
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (ni nr lst3 algo3 secret text) (I R name) (r expn) (Gi expr))
  (defstrand resp 2 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R) (r r) (Gi Gi))
  (defstrand blab-secret 2 (secret secret))
  (deflistener
    (hash "KDF" (hash I R secret "d") (exp (gen) (mul r Gi)) ni nr))
  (precedes ((0 1) (1 0)))
  (priority ((0 0) 4))
  (absent (r (exp (gen) Gi)))
  (neq ((exp (gen) Gi) (gen)))
  (uniq-gen r)
  (uniq-orig nr secret)
  (traces
    ((recv (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    ((recv "blab") (send secret))
    ((recv
       (hash "KDF" (hash I R secret "d") (exp (gen) (mul r Gi)) ni nr))
      (send
        (hash "KDF" (hash I R secret "d") (exp (gen) (mul r Gi)) ni
          nr)))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (i expn) (Gr expr) (I R name))
    (trace
      (send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab"))
    (uniq-orig ni)
    (uniq-gen i)
    (neq ((exp (gen) Gr) (gen)) (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (r expn) (Gi expr) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    (uniq-orig nr)
    (uniq-gen r)
    (neq ((exp (gen) Gi) (gen)))
    (absent (r (exp (gen) Gi)))
    (priority (0 4)))
  (defrole blab-secret
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (ni nr lst3 algo3 secret text) (I R name) (r expn) (Gi expr))
  (defstrand resp 2 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R) (r r) (Gi Gi))
  (defstrand blab-secret 2 (secret secret))
  (deflistener
    (hash "KDF" (hash R I secret "d") (exp (gen) (mul r Gi)) ni nr))
  (precedes ((0 1) (1 0)))
  (priority ((0 0) 4))
  (absent (r (exp (gen) Gi)))
  (neq ((exp (gen) Gi) (gen)))
  (uniq-gen r)
  (uniq-orig nr secret)
  (traces
    ((recv (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    ((recv "blab") (send secret))
    ((recv
       (hash "KDF" (hash R I secret "d") (exp (gen) (mul r Gi)) ni nr))
      (send
        (hash "KDF" (hash R I secret "d") (exp (gen) (mul r Gi)) ni
          nr)))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (i expn) (Gr expr) (I R name))
    (trace
      (send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab"))
    (uniq-orig ni)
    (uniq-gen i)
    (neq ((exp (gen) Gr) (gen)) (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (r expn) (Gi expr) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    (uniq-orig nr)
    (uniq-gen r)
    (neq ((exp (gen) Gi) (gen)))
    (absent (r (exp (gen) Gi)))
    (priority (0 4)))
  (defrole blab-secret
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (ni nr lst3 algo3 secret text) (I R name) (i expn) (Gr expr))
  (defstrand init 3 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R) (i i) (Gr Gr))
  (neq ((exp (gen) Gr) (gen)) (lst3 algo3))
  (non-orig secret)
  (uniq-gen i)
  (uniq-orig ni)
  (goals
    (forall
      ((iend node) (I R name) (ni nr lst3 algo3 secret text) (i expn)
        (Gr base))
      (implies
        (and (p "init" 2 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "algo3" iend algo3)
          (p "init" "lst3" iend lst3) (p "init" "i" iend i)
          (p "init" "Gr" iend Gr) (p "init" "secret" iend secret)
          (non secret))
        (or
          (exists ((r1 node)) (and (p "resp" 0 r1) (p "resp" "R" r1 R)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 R))))))
    (forall
      ((iend node) (I R name) (ni nr lst3 algo3 secret text) (i expn)
        (Gr base))
      (implies
        (and (p "init" 2 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "algo3" iend algo3)
          (p "init" "lst3" iend lst3) (p "init" "i" iend i)
          (p "init" "Gr" iend Gr) (p "init" "secret" iend secret)
          (non secret))
        (or
          (exists ((r1 node))
            (and (p "resp" 0 r1) (p "resp" "R" r1 R)
              (p "resp" "I" r1 I)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 R)
              (p "init" "R" i1 I))))))
    (forall
      ((iend node) (I R name) (ni nr lst3 algo3 secret text) (i expn)
        (Gr base))
      (implies
        (and (p "init" 2 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "algo3" iend algo3)
          (p "init" "lst3" iend lst3) (p "init" "i" iend i)
          (p "init" "Gr" iend Gr) (p "init" "secret" iend secret)
          (non secret))
        (exists ((r1 node))
          (and (p "resp" 0 r1) (p "resp" "R" r1 R)
            (p "resp" "I" r1 I))))))
  (traces
    ((send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab"))))

(defprotocol child diffie-hellman
  (defrole init
    (vars (ni nr lst3 algo3 secret text) (i expn) (Gr expr) (I R name))
    (trace
      (send (cat I R (enc lst3 ni (exp (gen) i) (hash I R secret "e"))))
      (recv
        (cat R I (enc algo3 nr (exp (gen) Gr) (hash R I secret "e"))))
      (send "blab"))
    (uniq-orig ni)
    (uniq-gen i)
    (neq ((exp (gen) Gr) (gen)) (lst3 algo3)))
  (defrole resp
    (vars (ni nr lst3 algo3 secret text) (r expn) (Gi expr) (I R name))
    (trace
      (recv
        (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))
    (uniq-orig nr)
    (uniq-gen r)
    (neq ((exp (gen) Gi) (gen)))
    (absent (r (exp (gen) Gi)))
    (priority (0 4)))
  (defrole blab-secret
    (vars (secret text))
    (trace (recv "blab") (send secret))
    (uniq-orig secret)))

(defskeleton child
  (vars (ni nr lst3 algo3 secret text) (I R name) (r expn) (Gi expr))
  (defstrand resp 2 (ni ni) (nr nr) (lst3 lst3) (algo3 algo3)
    (secret secret) (I I) (R R) (r r) (Gi Gi))
  (priority ((0 0) 4))
  (absent (r (exp (gen) Gi)))
  (neq ((exp (gen) Gi) (gen)))
  (non-orig secret)
  (uniq-gen r)
  (uniq-orig nr)
  (goals
    (forall
      ((rend node) (I R name) (ni nr lst3 algo3 secret text) (r expn)
        (Gi base))
      (implies
        (and (p "resp" 1 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "secret" rend secret)
          (p "resp" "lst3" rend lst3) (p "resp" "algo3" rend algo3)
          (p "resp" "r" rend r) (p "resp" "Gi" rend Gi) (non secret))
        (or
          (exists ((r1 node)) (and (p "resp" 0 r1) (p "resp" "R" r1 I)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 I))))))
    (forall
      ((rend node) (I R name) (ni nr lst3 algo3 secret text) (r expn)
        (Gi base))
      (implies
        (and (p "resp" 1 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "secret" rend secret)
          (p "resp" "lst3" rend lst3) (p "resp" "algo3" rend algo3)
          (p "resp" "r" rend r) (p "resp" "Gi" rend Gi) (non secret))
        (or
          (exists ((r1 node))
            (and (p "resp" 0 r1) (p "resp" "R" r1 I)
              (p "resp" "I" r1 R)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 I)
              (p "init" "R" i1 R))))))
    (forall
      ((rend node) (I R name) (ni nr lst3 algo3 secret text) (r expn)
        (Gi base))
      (implies
        (and (p "resp" 1 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "secret" rend secret)
          (p "resp" "lst3" rend lst3) (p "resp" "algo3" rend algo3)
          (p "resp" "r" rend r) (p "resp" "Gi" rend Gi) (non secret))
        (exists ((i1 node))
          (and (p "init" 0 i1) (p "init" "R" i1 R)
            (p "init" "I" i1 I)))))
    (forall
      ((rend node) (I R name) (ni nr lst3 algo3 secret text) (r expn)
        (Gi base))
      (implies
        (and (p "resp" 1 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "secret" rend secret)
          (p "resp" "lst3" rend lst3) (p "resp" "algo3" rend algo3)
          (p "resp" "r" rend r) (p "resp" "Gi" rend Gi) (non secret))
        (exists ((i1 node) (i expn))
          (and (p "init" 0 i1) (p "init" "R" i1 R) (p "init" "I" i1 I)
            (p "init" "ni" i1 ni) (p "init" "nr" i1 nr)
            (p "init" "algo3" i1 algo3) (p "init" "lst3" i1 lst3)
            (p "init" "secret" i1 secret)
            (p "init" "Gr" i1 (exp (gen) r)) (p "init" "i" i1 i))))))
  (comment
    "Responder point of view; agreement / weak agreement / aliveness goals")
  (traces
    ((recv (cat I R (enc lst3 ni (exp (gen) Gi) (hash I R secret "e"))))
      (send
        (cat R I (enc algo3 nr (exp (gen) r) (hash R I secret "e")))))))
