(herald "IKEv2 EAP" (algebra diffie-hellman))

(comment "CPSA 3.4.0")
(comment "All input read from IKEv2_eap.scm")

(defprotocol ikev2-eap diffie-hellman
  (defrole roleI
    (vars (I R name) (SPIi SPIr SA1 SA2 ni nr TSi TSr data) (i expn)
      (Gr expr) (eap eapok data))
    (trace (send (cat I R SPIi "0" SA1 (exp (gen) i) ni))
      (recv (cat R I (cat SPIi SPIr) SA1 (exp (gen) Gr) nr))
      (send
        (cat I R (cat SPIi SPIr)
          (enc I SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc R
            (enc SPIi SPIr SA1 (exp (gen) Gr) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr) R)
              (privk R)) eap
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (send
        (cat I R (cat SPIi SPIr)
          (enc eap
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc eapok
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (send
        (cat I R (cat SPIi SPIr)
          (enc
            (enc SPIi "0" SA1 (exp (gen) i) ni nr
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr) I)
              (privk I))
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc
            (enc SPIi SPIr SA1 (exp (gen) Gr) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr) R)
              (privk R)) SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr)))))
    (uniq-orig SPIi ni)
    (uniq-gen i))
  (defrole roleR
    (vars (I R name) (SPIi SPIr SA1 SA2 ni nr TSi TSr data) (r expn)
      (Gi expr) (eap eapok data))
    (trace (recv (cat I R SPIi "0" SA1 (exp (gen) Gi) ni))
      (send (cat R I (cat SPIi SPIr) SA1 (exp (gen) r) nr))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc I SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc R
            (enc SPIi SPIr SA1 (exp (gen) r) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr) R)
              (privk R)) eap
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc eap
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc eapok
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc
            (enc SPIi "0" SA1 (exp (gen) Gi) ni nr
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr) I)
              (privk I))
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc
            (enc SPIi SPIr SA1 (exp (gen) r) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr) R)
              (privk R)) SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr)))))
    (uniq-orig SPIr nr eap eapok)
    (uniq-gen r)
    (absent (r (exp (gen) Gi)))))

(defskeleton ikev2-eap
  (vars (ni nr SPIi SPIr SA1 SA2 TSi TSr eap eapok data) (I R name)
    (Gr expr) (i expn))
  (deflistener (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr))
  (defstrand roleI 8 (SPIi SPIi) (SPIr SPIr) (SA1 SA1) (SA2 SA2) (ni ni)
    (nr nr) (TSi TSi) (TSr TSr) (eap eap) (eapok eapok) (I I) (R R)
    (i i) (Gr Gr))
  (non-orig (privk I) (privk R))
  (uniq-gen i)
  (uniq-orig ni SPIi)
  (goals
    (forall
      ((I R name) (ni nr SPIi SPIr data) (Gr base) (i expn)
        (z z-0 node))
      (implies
        (and (p "roleI" 7 z) (p "roleI" "I" z I) (p "roleI" "R" z R)
          (p "roleI" "ni" z ni) (p "roleI" "nr" z nr)
          (p "roleI" "Gr" z Gr) (p "roleI" "i" z i)
          (p "roleI" "SPIi" z SPIi) (p "roleI" "SPIr" z SPIr)
          (p "" 0 z-0)
          (p "" "x" z-0 (hash "kdf" (cat ni nr (exp Gr i) SPIi SPIr)))
          (non (privk I)) (non (privk R))) (false))))
  (traces ((recv (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr)))
    ((send (cat I R SPIi "0" SA1 (exp (gen) i) ni))
      (recv (cat R I (cat SPIi SPIr) SA1 (exp (gen) Gr) nr))
      (send
        (cat I R (cat SPIi SPIr)
          (enc I SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc R
            (enc SPIi SPIr SA1 (exp (gen) Gr) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr) R)
              (privk R)) eap
            (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr))))
      (send
        (cat I R (cat SPIi SPIr)
          (enc eap
            (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc eapok
            (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr))))
      (send
        (cat I R (cat SPIi SPIr)
          (enc
            (enc SPIi "0" SA1 (exp (gen) i) ni nr
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr) I)
              (privk I))
            (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc
            (enc SPIi SPIr SA1 (exp (gen) Gr) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr) R)
              (privk R)) SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr)))))))

(defprotocol ikev2-eap diffie-hellman
  (defrole roleI
    (vars (I R name) (SPIi SPIr SA1 SA2 ni nr TSi TSr data) (i expn)
      (Gr expr) (eap eapok data))
    (trace (send (cat I R SPIi "0" SA1 (exp (gen) i) ni))
      (recv (cat R I (cat SPIi SPIr) SA1 (exp (gen) Gr) nr))
      (send
        (cat I R (cat SPIi SPIr)
          (enc I SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc R
            (enc SPIi SPIr SA1 (exp (gen) Gr) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr) R)
              (privk R)) eap
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (send
        (cat I R (cat SPIi SPIr)
          (enc eap
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc eapok
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (send
        (cat I R (cat SPIi SPIr)
          (enc
            (enc SPIi "0" SA1 (exp (gen) i) ni nr
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr) I)
              (privk I))
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc
            (enc SPIi SPIr SA1 (exp (gen) Gr) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr) R)
              (privk R)) SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr)))))
    (uniq-orig SPIi ni)
    (uniq-gen i))
  (defrole roleR
    (vars (I R name) (SPIi SPIr SA1 SA2 ni nr TSi TSr data) (r expn)
      (Gi expr) (eap eapok data))
    (trace (recv (cat I R SPIi "0" SA1 (exp (gen) Gi) ni))
      (send (cat R I (cat SPIi SPIr) SA1 (exp (gen) r) nr))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc I SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc R
            (enc SPIi SPIr SA1 (exp (gen) r) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr) R)
              (privk R)) eap
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc eap
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc eapok
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc
            (enc SPIi "0" SA1 (exp (gen) Gi) ni nr
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr) I)
              (privk I))
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc
            (enc SPIi SPIr SA1 (exp (gen) r) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr) R)
              (privk R)) SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr)))))
    (uniq-orig SPIr nr eap eapok)
    (uniq-gen r)
    (absent (r (exp (gen) Gi)))))

(defskeleton ikev2-eap
  (vars (ni nr SPIi SPIr SA1 SA2 TSi TSr eap eapok data) (I R name)
    (Gi expr) (r expn))
  (deflistener (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr))
  (defstrand roleR 8 (SPIi SPIi) (SPIr SPIr) (SA1 SA1) (SA2 SA2) (ni ni)
    (nr nr) (TSi TSi) (TSr TSr) (eap eap) (eapok eapok) (I I) (R R)
    (r r) (Gi Gi))
  (absent (r (exp (gen) Gi)))
  (non-orig (privk I) (privk R))
  (uniq-gen r)
  (uniq-orig nr SPIr eap eapok)
  (goals
    (forall
      ((I R name) (ni nr SPIi SPIr data) (Gi base) (r expn)
        (z z-0 node))
      (implies
        (and (p "roleR" 7 z) (p "roleR" "I" z I) (p "roleR" "R" z R)
          (p "roleR" "ni" z ni) (p "roleR" "nr" z nr)
          (p "roleR" "Gi" z Gi) (p "roleR" "r" z r)
          (p "roleR" "SPIi" z SPIi) (p "roleR" "SPIr" z SPIr)
          (p "" 0 z-0)
          (p "" "x" z-0 (hash "kdf" (cat ni nr (exp Gi r) SPIi SPIr)))
          (non (privk I)) (non (privk R))) (false))))
  (traces ((recv (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr)))
    ((recv (cat I R SPIi "0" SA1 (exp (gen) Gi) ni))
      (send (cat R I (cat SPIi SPIr) SA1 (exp (gen) r) nr))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc I SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc R
            (enc SPIi SPIr SA1 (exp (gen) r) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr) R)
              (privk R)) eap
            (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr))))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc eap
            (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc eapok
            (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr))))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc
            (enc SPIi "0" SA1 (exp (gen) Gi) ni nr
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr) I)
              (privk I))
            (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc
            (enc SPIi SPIr SA1 (exp (gen) r) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr) R)
              (privk R)) SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr)))))))

(defprotocol ikev2-eap diffie-hellman
  (defrole roleI
    (vars (I R name) (SPIi SPIr SA1 SA2 ni nr TSi TSr data) (i expn)
      (Gr expr) (eap eapok data))
    (trace (send (cat I R SPIi "0" SA1 (exp (gen) i) ni))
      (recv (cat R I (cat SPIi SPIr) SA1 (exp (gen) Gr) nr))
      (send
        (cat I R (cat SPIi SPIr)
          (enc I SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc R
            (enc SPIi SPIr SA1 (exp (gen) Gr) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr) R)
              (privk R)) eap
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (send
        (cat I R (cat SPIi SPIr)
          (enc eap
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc eapok
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (send
        (cat I R (cat SPIi SPIr)
          (enc
            (enc SPIi "0" SA1 (exp (gen) i) ni nr
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr) I)
              (privk I))
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc
            (enc SPIi SPIr SA1 (exp (gen) Gr) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr) R)
              (privk R)) SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr)))))
    (uniq-orig SPIi ni)
    (uniq-gen i))
  (defrole roleR
    (vars (I R name) (SPIi SPIr SA1 SA2 ni nr TSi TSr data) (r expn)
      (Gi expr) (eap eapok data))
    (trace (recv (cat I R SPIi "0" SA1 (exp (gen) Gi) ni))
      (send (cat R I (cat SPIi SPIr) SA1 (exp (gen) r) nr))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc I SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc R
            (enc SPIi SPIr SA1 (exp (gen) r) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr) R)
              (privk R)) eap
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc eap
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc eapok
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc
            (enc SPIi "0" SA1 (exp (gen) Gi) ni nr
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr) I)
              (privk I))
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc
            (enc SPIi SPIr SA1 (exp (gen) r) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr) R)
              (privk R)) SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr)))))
    (uniq-orig SPIr nr eap eapok)
    (uniq-gen r)
    (absent (r (exp (gen) Gi)))))

(defskeleton ikev2-eap
  (vars (ni nr SPIi SPIr SA1 SA2 TSi TSr eap eapok data) (I R name)
    (Gr expr) (i expn))
  (defstrand roleI 8 (SPIi SPIi) (SPIr SPIr) (SA1 SA1) (SA2 SA2) (ni ni)
    (nr nr) (TSi TSi) (TSr TSr) (eap eap) (eapok eapok) (I I) (R R)
    (i i) (Gr Gr))
  (non-orig (privk I) (privk R))
  (uniq-gen i)
  (uniq-orig ni SPIi)
  (goals
    (forall
      ((I R name) (ni nr SPIi SPIr SA1 SA2 TSi TSr eap data) (Gr base)
        (i expn) (z node))
      (implies
        (and (p "roleI" 7 z) (p "roleI" "I" z I) (p "roleI" "R" z R)
          (p "roleI" "ni" z ni) (p "roleI" "nr" z nr)
          (p "roleI" "Gr" z Gr) (p "roleI" "i" z i)
          (p "roleI" "SPIi" z SPIi) (p "roleI" "SPIr" z SPIr)
          (p "roleI" "SA1" z SA1) (p "roleI" "SA2" z SA2)
          (p "roleI" "TSi" z TSi) (p "roleI" "TSr" z TSr)
          (p "roleI" "eap" z eap) (non (privk I)) (non (privk R)))
        (exists ((z-1 node) (Gi base) (r expn))
          (and (p "roleR" 7 z-1) (p "roleR" "I" z-1 I)
            (p "roleR" "R" z-1 R) (p "roleR" "ni" z-1 ni)
            (p "roleR" "nr" z-1 nr) (p "roleR" "Gi" z-1 Gi)
            (p "roleR" "r" z-1 r) (p "roleR" "SPIi" z-1 SPIi)
            (p "roleR" "SPIr" z-1 SPIr) (p "roleR" "SA1" z-1 SA1)
            (p "roleR" "SA2" z-1 SA2) (p "roleR" "TSi" z-1 TSi)
            (p "roleR" "TSr" z-1 TSr) (p "roleR" "eap" z-1 eap)
            (= (exp Gr i) (exp Gi r)))))))
  (traces
    ((send (cat I R SPIi "0" SA1 (exp (gen) i) ni))
      (recv (cat R I (cat SPIi SPIr) SA1 (exp (gen) Gr) nr))
      (send
        (cat I R (cat SPIi SPIr)
          (enc I SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc R
            (enc SPIi SPIr SA1 (exp (gen) Gr) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr) R)
              (privk R)) eap
            (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr))))
      (send
        (cat I R (cat SPIi SPIr)
          (enc eap
            (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc eapok
            (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr))))
      (send
        (cat I R (cat SPIi SPIr)
          (enc
            (enc SPIi "0" SA1 (exp (gen) i) ni nr
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr) I)
              (privk I))
            (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc
            (enc SPIi SPIr SA1 (exp (gen) Gr) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr) R)
              (privk R)) SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul Gr i)) SPIi SPIr)))))))

(defprotocol ikev2-eap diffie-hellman
  (defrole roleI
    (vars (I R name) (SPIi SPIr SA1 SA2 ni nr TSi TSr data) (i expn)
      (Gr expr) (eap eapok data))
    (trace (send (cat I R SPIi "0" SA1 (exp (gen) i) ni))
      (recv (cat R I (cat SPIi SPIr) SA1 (exp (gen) Gr) nr))
      (send
        (cat I R (cat SPIi SPIr)
          (enc I SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc R
            (enc SPIi SPIr SA1 (exp (gen) Gr) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr) R)
              (privk R)) eap
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (send
        (cat I R (cat SPIi SPIr)
          (enc eap
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc eapok
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (send
        (cat I R (cat SPIi SPIr)
          (enc
            (enc SPIi "0" SA1 (exp (gen) i) ni nr
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr) I)
              (privk I))
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr))))
      (recv
        (cat R I (cat SPIi SPIr)
          (enc
            (enc SPIi SPIr SA1 (exp (gen) Gr) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr) R)
              (privk R)) SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul i Gr)) SPIi SPIr)))))
    (uniq-orig SPIi ni)
    (uniq-gen i))
  (defrole roleR
    (vars (I R name) (SPIi SPIr SA1 SA2 ni nr TSi TSr data) (r expn)
      (Gi expr) (eap eapok data))
    (trace (recv (cat I R SPIi "0" SA1 (exp (gen) Gi) ni))
      (send (cat R I (cat SPIi SPIr) SA1 (exp (gen) r) nr))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc I SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc R
            (enc SPIi SPIr SA1 (exp (gen) r) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr) R)
              (privk R)) eap
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc eap
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc eapok
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc
            (enc SPIi "0" SA1 (exp (gen) Gi) ni nr
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr) I)
              (privk I))
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc
            (enc SPIi SPIr SA1 (exp (gen) r) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr) R)
              (privk R)) SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul r Gi)) SPIi SPIr)))))
    (uniq-orig SPIr nr eap eapok)
    (uniq-gen r)
    (absent (r (exp (gen) Gi)))))

(defskeleton ikev2-eap
  (vars (ni nr SPIi SPIr SA1 SA2 TSi TSr eap eapok data) (I R name)
    (Gi expr) (r expn))
  (defstrand roleR 8 (SPIi SPIi) (SPIr SPIr) (SA1 SA1) (SA2 SA2) (ni ni)
    (nr nr) (TSi TSi) (TSr TSr) (eap eap) (eapok eapok) (I I) (R R)
    (r r) (Gi Gi))
  (absent (r (exp (gen) Gi)))
  (non-orig (privk I) (privk R))
  (uniq-gen r)
  (uniq-orig nr SPIr eap eapok)
  (goals
    (forall
      ((I R name) (ni nr SPIi SPIr SA1 SA2 TSi TSr eap data) (Gi base)
        (r expn) (z node))
      (implies
        (and (p "roleR" 7 z) (p "roleR" "I" z I) (p "roleR" "R" z R)
          (p "roleR" "ni" z ni) (p "roleR" "nr" z nr)
          (p "roleR" "Gi" z Gi) (p "roleR" "r" z r)
          (p "roleR" "SPIi" z SPIi) (p "roleR" "SPIr" z SPIr)
          (p "roleR" "SA1" z SA1) (p "roleR" "SA2" z SA2)
          (p "roleR" "TSi" z TSi) (p "roleR" "TSr" z TSr)
          (p "roleR" "eap" z eap) (non (privk I)) (non (privk R)))
        (exists ((z-1 node) (Gr base) (i expn))
          (and (p "roleI" 6 z-1) (p "roleI" "I" z-1 I)
            (p "roleI" "R" z-1 R) (p "roleI" "ni" z-1 ni)
            (p "roleI" "nr" z-1 nr) (p "roleI" "Gr" z-1 Gr)
            (p "roleI" "i" z-1 i) (p "roleI" "SPIi" z-1 SPIi)
            (p "roleI" "SPIr" z-1 SPIr) (p "roleI" "SA1" z-1 SA1)
            (p "roleI" "SA2" z-1 SA2) (p "roleI" "TSi" z-1 TSi)
            (p "roleI" "TSr" z-1 TSr) (p "roleI" "eap" z-1 eap)
            (= (exp Gr i) (exp Gi r)))))))
  (traces
    ((recv (cat I R SPIi "0" SA1 (exp (gen) Gi) ni))
      (send (cat R I (cat SPIi SPIr) SA1 (exp (gen) r) nr))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc I SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc R
            (enc SPIi SPIr SA1 (exp (gen) r) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr) R)
              (privk R)) eap
            (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr))))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc eap
            (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc eapok
            (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr))))
      (recv
        (cat I R (cat SPIi SPIr)
          (enc
            (enc SPIi "0" SA1 (exp (gen) Gi) ni nr
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr) I)
              (privk I))
            (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr))))
      (send
        (cat R I (cat SPIi SPIr)
          (enc
            (enc SPIi SPIr SA1 (exp (gen) r) nr ni
              (hash "prf"
                (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr) R)
              (privk R)) SA2 TSi TSr
            (hash "kdf" ni nr (exp (gen) (mul Gi r)) SPIi SPIr)))))))
