(herald "IKEv2 Sig" (algebra diffie-hellman) (bound 15) (limit 8000)
  (noisochk))

(comment "CPSA 3.4.0")
(comment "All input read from IKEv2_sig2_child.scm")
(comment "Isomorphism checking disabled")
(comment "Step count limited to 8000")
(comment "Strand count bounded at 15")

(defprotocol sigChild2 diffie-hellman
  (defrole init
    (vars
      (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr text)
      (Gr Gt expr) (i j expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send
        (cat I R ci cr
          (enc lst3 mi (exp (gen) j)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc algo3 mr (exp (gen) Gt)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni mi)
    (uniq-gen i j)
    (absent (j (exp (gen) i)) (j (exp (gen) Gr))
      (j (exp (gen) (mul Gr i)))))
  (defrole resp
    (vars
      (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr text)
      (Gi Gj expr) (r t expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (recv
        (cat I R ci cr
          (enc lst3 mi (exp (gen) Gj)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc algo3 mr (exp (gen) t)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr mr)
    (uniq-gen r t)
    (absent (r (exp (gen) Gi)) (t (exp (gen) Gi)) (t (exp (gen) r))
      (t (exp (gen) (mul Gi r))) (t (exp (gen) Gj))))
  (defrole blab-akey
    (vars (key akey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton sigChild2
  (vars
    (ni nr ci cr lst1 lst2 algo1 algo2 lst3 algo3 mi mr TSi TSr text)
    (I R name) (i j expn) (Gr Gt expr))
  (defstrand blab-akey 2 (key (privk R)))
  (defstrand init 7 (ci ci) (cr cr) (ni ni) (nr nr) (mi mi) (mr mr)
    (lst1 lst1) (algo1 algo1) (lst2 lst2) (algo2 algo2) (lst3 lst3)
    (algo3 algo3) (TSi TSi) (TSr TSr) (R R) (I I) (Gr Gr) (Gt Gt) (i i)
    (j j))
  (precedes ((1 6) (0 0)))
  (absent (j (exp (gen) i)) (j (exp (gen) Gr))
    (j (exp (gen) (mul i Gr))))
  (pen-non-orig (privk R))
  (uniq-gen i j)
  (uniq-orig ni ci mi (privk R))
  (goals
    (forall
      ((iend brend brstart node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 lst3 algo3 mi mr TSi TSr
          text) (i j expn) (Gr Gt base))
      (implies
        (and (p "init" 6 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "ci" iend ci)
          (p "init" "cr" iend cr) (p "init" "mi" iend mi)
          (p "init" "mr" iend mr) (p "init" "lst1" iend lst1)
          (p "init" "lst2" iend lst2) (p "init" "algo3" iend algo3)
          (p "init" "lst3" iend lst3) (p "init" "i" iend i)
          (p "init" "Gr" iend Gr) (p "init" "j" iend j)
          (p "init" "Gt" iend Gt) (p "init" "algo1" iend algo1)
          (p "init" "algo2" iend algo2) (p "init" "TSi" iend TSi)
          (p "init" "TSr" iend TSr) (p "blab-akey" 1 brend)
          (str-prec brstart brend) (p "blab-akey" 0 brstart)
          (p "blab-akey" "key" brend (privk R)) (prec iend brstart)
          (pnon (privk R)))
        (or
          (exists ((r1 node)) (and (p "resp" 0 r1) (p "resp" "R" r1 R)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 R))))))
    (forall
      ((iend brend brstart node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 lst3 algo3 mi mr TSi TSr
          text) (i j expn) (Gr Gt base))
      (implies
        (and (p "init" 6 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "ci" iend ci)
          (p "init" "cr" iend cr) (p "init" "mi" iend mi)
          (p "init" "mr" iend mr) (p "init" "lst1" iend lst1)
          (p "init" "lst2" iend lst2) (p "init" "algo3" iend algo3)
          (p "init" "lst3" iend lst3) (p "init" "i" iend i)
          (p "init" "Gr" iend Gr) (p "init" "j" iend j)
          (p "init" "Gt" iend Gt) (p "init" "algo1" iend algo1)
          (p "init" "algo2" iend algo2) (p "init" "TSi" iend TSi)
          (p "init" "TSr" iend TSr) (p "blab-akey" 1 brend)
          (str-prec brstart brend) (p "blab-akey" 0 brstart)
          (p "blab-akey" "key" brend (privk R)) (prec iend brstart)
          (pnon (privk R)))
        (or
          (exists ((r1 node))
            (and (p "resp" 0 r1) (p "resp" "R" r1 R)
              (p "resp" "I" r1 I)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 R)
              (p "init" "R" i1 I))))))
    (forall
      ((iend brend brstart node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 lst3 algo3 mi mr TSi TSr
          text) (i j expn) (Gr Gt base))
      (implies
        (and (p "init" 6 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "ci" iend ci)
          (p "init" "cr" iend cr) (p "init" "mi" iend mi)
          (p "init" "mr" iend mr) (p "init" "lst1" iend lst1)
          (p "init" "lst2" iend lst2) (p "init" "algo3" iend algo3)
          (p "init" "lst3" iend lst3) (p "init" "i" iend i)
          (p "init" "Gr" iend Gr) (p "init" "j" iend j)
          (p "init" "Gt" iend Gt) (p "init" "algo1" iend algo1)
          (p "init" "algo2" iend algo2) (p "init" "TSi" iend TSi)
          (p "init" "TSr" iend TSr) (p "blab-akey" 1 brend)
          (str-prec brstart brend) (p "blab-akey" 0 brstart)
          (p "blab-akey" "key" brend (privk R)) (prec iend brstart)
          (pnon (privk R)))
        (exists ((r1 node) (Gi Gj base) (r t expn))
          (and (p "resp" 0 r1) (p "resp" "R" r1 R) (p "resp" "I" r1 I)
            (p "resp" "Gi" r1 Gi) (p "resp" "r" r1 r)
            (p "resp" "Gj" r1 Gj) (p "resp" "t" r1 t)
            (= (exp Gj t) (exp Gt j)) (= (exp Gi r) (exp Gr i))))))
    (forall
      ((iend brend brstart node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 lst3 algo3 mi mr TSi TSr
          text) (i j expn) (Gr Gt base))
      (implies
        (and (p "init" 6 iend) (p "init" "R" iend R)
          (p "init" "I" iend I) (p "init" "ni" iend ni)
          (p "init" "nr" iend nr) (p "init" "ci" iend ci)
          (p "init" "cr" iend cr) (p "init" "mi" iend mi)
          (p "init" "mr" iend mr) (p "init" "lst1" iend lst1)
          (p "init" "lst2" iend lst2) (p "init" "algo3" iend algo3)
          (p "init" "lst3" iend lst3) (p "init" "i" iend i)
          (p "init" "Gr" iend Gr) (p "init" "j" iend j)
          (p "init" "Gt" iend Gt) (p "init" "algo1" iend algo1)
          (p "init" "algo2" iend algo2) (p "init" "TSi" iend TSi)
          (p "init" "TSr" iend TSr) (p "blab-akey" 1 brend)
          (str-prec brstart brend) (p "blab-akey" 0 brstart)
          (p "blab-akey" "key" brend (privk R)) (prec iend brstart)
          (pnon (privk R)))
        (exists ((r1 node) (r expn))
          (and (p "resp" 0 r1) (p "resp" "R" r1 R) (p "resp" "I" r1 I)
            (p "resp" "ni" r1 ni) (p "resp" "nr" r1 nr)
            (p "resp" "r" r1 r) (p "resp" "ci" r1 ci)
            (p "resp" "cr" r1 cr) (p "resp" "lst1" r1 lst1)
            (p "resp" "lst2" r1 lst2) (p "resp" "algo1" r1 algo1)
            (p "resp" "TSi" r1 TSi) (p "resp" "TSr" r1 TSr)
            (p "resp" "Gi" r1 (exp (gen) i))
            (p "resp" "algo2" r1 algo2))))))
  (traces ((recv "blab") (send (privk R)))
    ((send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr))))
      (send
        (cat I R ci cr
          (enc lst3 mi (exp (gen) j)
            (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr))))
      (recv
        (cat R I ci cr
          (enc algo3 mr (exp (gen) Gt)
            (hash "KDF" ni nr (exp (gen) (mul i Gr)) ci cr))))
      (send "blab"))))

(defprotocol sigChild2 diffie-hellman
  (defrole init
    (vars
      (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr text)
      (Gr Gt expr) (i j expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send
        (cat I R ci cr
          (enc lst3 mi (exp (gen) j)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc algo3 mr (exp (gen) Gt)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni mi)
    (uniq-gen i j)
    (absent (j (exp (gen) i)) (j (exp (gen) Gr))
      (j (exp (gen) (mul Gr i)))))
  (defrole resp
    (vars
      (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr text)
      (Gi Gj expr) (r t expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (recv
        (cat I R ci cr
          (enc lst3 mi (exp (gen) Gj)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc algo3 mr (exp (gen) t)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr mr)
    (uniq-gen r t)
    (absent (r (exp (gen) Gi)) (t (exp (gen) Gi)) (t (exp (gen) r))
      (t (exp (gen) (mul Gi r))) (t (exp (gen) Gj))))
  (defrole blab-akey
    (vars (key akey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton sigChild2
  (vars
    (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr mi mr lst3 algo3 text)
    (I R name) (r expn) (Gi Gj expr) (t expn))
  (defstrand blab-akey 2 (key (privk I)))
  (defstrand resp 6 (ci ci) (cr cr) (ni ni) (nr nr) (mi mi) (mr mr)
    (lst1 lst1) (algo1 algo1) (lst2 lst2) (algo2 algo2) (lst3 lst3)
    (algo3 algo3) (TSi TSi) (TSr TSr) (R R) (I I) (Gi Gi) (Gj Gj) (r r)
    (t t))
  (precedes ((1 5) (0 0)))
  (absent (r (exp (gen) Gi)) (t (exp (gen) Gi)) (t (exp (gen) r))
    (t (exp (gen) (mul r Gi))) (t (exp (gen) Gj)))
  (pen-non-orig (privk I))
  (uniq-gen r t)
  (uniq-orig nr cr mr (privk I))
  (goals
    (forall
      ((rend biend bistart node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr text) (r expn)
        (Gi base))
      (implies
        (and (p "resp" 5 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "ci" rend ci)
          (p "resp" "cr" rend cr) (p "resp" "lst1" rend lst1)
          (p "resp" "algo1" rend algo1) (p "resp" "r" rend r)
          (p "resp" "lst2" rend lst2) (p "resp" "algo2" rend algo2)
          (p "resp" "Gi" rend Gi) (p "resp" "TSi" rend TSi)
          (p "resp" "TSr" rend TSr) (p "blab-akey" 1 biend)
          (str-prec bistart biend) (p "blab-akey" 0 bistart)
          (p "blab-akey" "key" biend (privk I)) (prec rend bistart)
          (pnon (privk I)))
        (or
          (exists ((r1 node)) (and (p "resp" 0 r1) (p "resp" "R" r1 I)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 I))))))
    (forall
      ((rend biend bistart node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr text) (r expn)
        (Gi base))
      (implies
        (and (p "resp" 5 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "ci" rend ci)
          (p "resp" "cr" rend cr) (p "resp" "lst1" rend lst1)
          (p "resp" "algo1" rend algo1) (p "resp" "r" rend r)
          (p "resp" "lst2" rend lst2) (p "resp" "algo2" rend algo2)
          (p "resp" "Gi" rend Gi) (p "resp" "TSi" rend TSi)
          (p "resp" "TSr" rend TSr) (p "blab-akey" 1 biend)
          (str-prec bistart biend) (p "blab-akey" 0 bistart)
          (p "blab-akey" "key" biend (privk I)) (prec rend bistart)
          (pnon (privk I)))
        (or
          (exists ((r1 node))
            (and (p "resp" 0 r1) (p "resp" "R" r1 I)
              (p "resp" "I" r1 R)))
          (exists ((i1 node))
            (and (p "init" 0 i1) (p "init" "I" i1 I)
              (p "init" "R" i1 R))))))
    (forall
      ((rend biend bistart node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr text) (r expn)
        (Gi base))
      (implies
        (and (p "resp" 5 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "ci" rend ci)
          (p "resp" "cr" rend cr) (p "resp" "lst1" rend lst1)
          (p "resp" "algo1" rend algo1) (p "resp" "r" rend r)
          (p "resp" "lst2" rend lst2) (p "resp" "algo2" rend algo2)
          (p "resp" "Gi" rend Gi) (p "resp" "TSi" rend TSi)
          (p "resp" "TSr" rend TSr) (p "blab-akey" 1 biend)
          (str-prec bistart biend) (p "blab-akey" 0 bistart)
          (p "blab-akey" "key" biend (privk I)) (prec rend bistart)
          (pnon (privk I)))
        (exists ((i1 node) (Gr base) (i expn))
          (and (p "init" 0 i1) (p "init" "R" i1 R) (p "init" "I" i1 I)
            (p "init" "Gr" i1 Gr) (p "init" "i" i1 i)
            (= (exp Gi r) (exp Gr i))))))
    (forall
      ((rend biend bistart node) (I R name)
        (ni nr ci cr lst1 lst2 algo1 algo2 TSi TSr text) (r expn)
        (Gi base))
      (implies
        (and (p "resp" 5 rend) (p "resp" "R" rend R)
          (p "resp" "I" rend I) (p "resp" "ni" rend ni)
          (p "resp" "nr" rend nr) (p "resp" "ci" rend ci)
          (p "resp" "cr" rend cr) (p "resp" "lst1" rend lst1)
          (p "resp" "algo1" rend algo1) (p "resp" "r" rend r)
          (p "resp" "lst2" rend lst2) (p "resp" "algo2" rend algo2)
          (p "resp" "Gi" rend Gi) (p "resp" "TSi" rend TSi)
          (p "resp" "TSr" rend TSr) (p "blab-akey" 1 biend)
          (str-prec bistart biend) (p "blab-akey" 0 bistart)
          (p "blab-akey" "key" biend (privk I)) (prec rend bistart)
          (pnon (privk I)))
        (exists ((i1 node) (i expn))
          (and (p "init" 0 i1) (p "init" "R" i1 R) (p "init" "I" i1 I)
            (p "init" "ni" i1 ni) (p "init" "nr" i1 nr)
            (p "init" "ci" i1 ci) (p "init" "cr" i1 cr)
            (p "init" "algo1" i1 algo1) (p "init" "lst1" i1 lst1)
            (p "init" "algo2" i1 algo2) (p "init" "lst2" i1 lst2)
            (p "init" "TSr" i1 TSr) (p "init" "TSi" i1 TSi)
            (p "init" "Gr" i1 (exp (gen) r)) (p "init" "i" i1 i))))))
  (comment
    "Responder point of view; agreement / weak agreement / aliveness goals")
  (traces ((recv "blab") (send (privk I)))
    ((recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr))))
      (recv
        (cat I R ci cr
          (enc lst3 mi (exp (gen) Gj)
            (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr))))
      (send
        (cat R I ci cr
          (enc algo3 mr (exp (gen) t)
            (hash "KDF" ni nr (exp (gen) (mul r Gi)) ci cr)))))))

(defprotocol sigChild2 diffie-hellman
  (defrole init
    (vars
      (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr text)
      (Gr Gt expr) (i j expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send
        (cat I R ci cr
          (enc lst3 mi (exp (gen) j)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc algo3 mr (exp (gen) Gt)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni mi)
    (uniq-gen i j)
    (absent (j (exp (gen) i)) (j (exp (gen) Gr))
      (j (exp (gen) (mul Gr i)))))
  (defrole resp
    (vars
      (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr text)
      (Gi Gj expr) (r t expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (recv
        (cat I R ci cr
          (enc lst3 mi (exp (gen) Gj)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc algo3 mr (exp (gen) t)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr mr)
    (uniq-gen r t)
    (absent (r (exp (gen) Gi)) (t (exp (gen) Gi)) (t (exp (gen) r))
      (t (exp (gen) (mul Gi r))) (t (exp (gen) Gj))))
  (defrole blab-akey
    (vars (key akey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton sigChild2
  (vars
    (ci cr ni nr mi TSi TSr mr lst1 algo1 lst2 algo2 lst3 algo3 text)
    (R I name) (Gr Gt expr) (i j expn))
  (defstrand init 6 (ci ci) (cr cr) (ni ni) (nr nr) (mi mi) (mr mr)
    (lst1 lst1) (algo1 algo1) (lst2 lst2) (algo2 algo2) (lst3 lst3)
    (algo3 algo3) (TSi TSi) (TSr TSr) (R R) (I I) (Gr Gr) (Gt Gt) (i i)
    (j j))
  (deflistener (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
  (absent (j (exp (gen) i)) (j (exp (gen) Gr))
    (j (exp (gen) (mul Gr i))))
  (non-orig (privk R) (privk I))
  (uniq-gen i j)
  (uniq-orig ci ni mi)
  (traces
    ((send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send
        (cat I R ci cr
          (enc lst3 mi (exp (gen) j)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc algo3 mr (exp (gen) Gt)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr)))))
    ((recv (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
      (send (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr)))))

(defprotocol sigChild2 diffie-hellman
  (defrole init
    (vars
      (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr text)
      (Gr Gt expr) (i j expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send
        (cat I R ci cr
          (enc lst3 mi (exp (gen) j)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc algo3 mr (exp (gen) Gt)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni mi)
    (uniq-gen i j)
    (absent (j (exp (gen) i)) (j (exp (gen) Gr))
      (j (exp (gen) (mul Gr i)))))
  (defrole resp
    (vars
      (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr text)
      (Gi Gj expr) (r t expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (recv
        (cat I R ci cr
          (enc lst3 mi (exp (gen) Gj)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc algo3 mr (exp (gen) t)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr mr)
    (uniq-gen r t)
    (absent (r (exp (gen) Gi)) (t (exp (gen) Gi)) (t (exp (gen) r))
      (t (exp (gen) (mul Gi r))) (t (exp (gen) Gj))))
  (defrole blab-akey
    (vars (key akey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton sigChild2
  (vars
    (ci cr mi mr ni nr TSi TSr lst1 algo1 lst2 algo2 lst3 algo3 text)
    (R I name) (Gi Gj expr) (r t expn))
  (defstrand resp 6 (ci ci) (cr cr) (ni ni) (nr nr) (mi mi) (mr mr)
    (lst1 lst1) (algo1 algo1) (lst2 lst2) (algo2 algo2) (lst3 lst3)
    (algo3 algo3) (TSi TSi) (TSr TSr) (R R) (I I) (Gi Gi) (Gj Gj) (r r)
    (t t))
  (deflistener (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
  (absent (r (exp (gen) Gi)) (t (exp (gen) Gi)) (t (exp (gen) r))
    (t (exp (gen) (mul Gi r))) (t (exp (gen) Gj)))
  (non-orig (privk R) (privk I))
  (uniq-gen r t)
  (uniq-orig cr mr nr)
  (traces
    ((recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (recv
        (cat I R ci cr
          (enc lst3 mi (exp (gen) Gj)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc algo3 mr (exp (gen) t)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    ((recv (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
      (send (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))

(defprotocol sigChild2 diffie-hellman
  (defrole init
    (vars
      (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr text)
      (Gr Gt expr) (i j expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send
        (cat I R ci cr
          (enc lst3 mi (exp (gen) j)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc algo3 mr (exp (gen) Gt)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni mi)
    (uniq-gen i j)
    (absent (j (exp (gen) i)) (j (exp (gen) Gr))
      (j (exp (gen) (mul Gr i)))))
  (defrole resp
    (vars
      (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr text)
      (Gi Gj expr) (r t expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (recv
        (cat I R ci cr
          (enc lst3 mi (exp (gen) Gj)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc algo3 mr (exp (gen) t)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr mr)
    (uniq-gen r t)
    (absent (r (exp (gen) Gi)) (t (exp (gen) Gi)) (t (exp (gen) r))
      (t (exp (gen) (mul Gi r))) (t (exp (gen) Gj))))
  (defrole blab-akey
    (vars (key akey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton sigChild2
  (vars
    (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr mi-0
      text) (R I name) (i j r t expn))
  (defstrand init 7 (ci ci) (cr cr) (ni ni) (nr nr) (mi mi) (mr mr)
    (lst1 lst1) (algo1 algo1) (lst2 lst2) (algo2 algo2) (lst3 lst3)
    (algo3 algo3) (TSi TSi) (TSr TSr) (R R) (I I) (Gr r) (Gt t) (i i)
    (j j))
  (defstrand resp 6 (ci ci) (cr cr) (ni ni) (nr nr) (mi mi-0) (mr mr)
    (lst1 lst1) (algo1 algo1) (lst2 lst2) (algo2 algo2) (lst3 lst3)
    (algo3 algo3) (TSi TSi) (TSr TSr) (R R) (I I) (Gi i) (Gj j) (r r)
    (t t))
  (defstrand blab-akey 2 (key (privk I)))
  (defstrand blab-akey 2 (key (privk R)))
  (deflistener (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr))
  (precedes ((0 0) (1 0)) ((0 2) (1 2)) ((0 6) (2 0)) ((0 6) (3 0))
    ((1 1) (0 1)) ((1 5) (0 5)))
  (absent (r (exp (gen) i)) (t (exp (gen) i)) (t (exp (gen) r))
    (t (exp (gen) (mul i r))) (t (exp (gen) j)) (j (exp (gen) i))
    (j (exp (gen) r)) (j (exp (gen) (mul i r))))
  (ind-zero-in (r (exp (gen) i)))
  (pen-non-orig (privk R) (privk I))
  (uniq-gen i j r t)
  (uniq-orig ci cr ni nr mi mr (privk R) (privk I))
  (traces
    ((send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) r) nr))
      (send
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr))))
      (send
        (cat I R ci cr
          (enc lst3 mi (exp (gen) j)
            (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr))))
      (recv
        (cat R I ci cr
          (enc algo3 mr (exp (gen) t)
            (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr))))
      (send "blab"))
    ((recv (cat I R ci "0" lst1 (exp (gen) i) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr))))
      (recv
        (cat I R ci cr
          (enc lst3 mi-0 (exp (gen) j)
            (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr))))
      (send
        (cat R I ci cr
          (enc algo3 mr (exp (gen) t)
            (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr)))))
    ((recv "blab") (send (privk I))) ((recv "blab") (send (privk R)))
    ((recv (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr))
      (send (hash "KDF" ni nr (exp (gen) (mul i r)) ci cr)))))

(defprotocol sigChild2 diffie-hellman
  (defrole init
    (vars
      (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr text)
      (Gr Gt expr) (i j expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send
        (cat I R ci cr
          (enc lst3 mi (exp (gen) j)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc algo3 mr (exp (gen) Gt)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni mi)
    (uniq-gen i j)
    (absent (j (exp (gen) i)) (j (exp (gen) Gr))
      (j (exp (gen) (mul Gr i)))))
  (defrole resp
    (vars
      (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr text)
      (Gi Gj expr) (r t expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (recv
        (cat I R ci cr
          (enc lst3 mi (exp (gen) Gj)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc algo3 mr (exp (gen) t)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr mr)
    (uniq-gen r t)
    (absent (r (exp (gen) Gi)) (t (exp (gen) Gi)) (t (exp (gen) r))
      (t (exp (gen) (mul Gi r))) (t (exp (gen) Gj))))
  (defrole blab-akey
    (vars (key akey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton sigChild2
  (vars
    (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr mi mr lst3 algo3 text)
    (R I name) (Gr expr) (i expn) (Gt expr) (j expn))
  (defstrand init 7 (ci ci) (cr cr) (ni ni) (nr nr) (mi mi) (mr mr)
    (lst1 lst1) (algo1 algo1) (lst2 lst2) (algo2 algo2) (lst3 lst3)
    (algo3 algo3) (TSi TSi) (TSr TSr) (R R) (I I) (Gr Gr) (Gt Gt) (i i)
    (j j))
  (defstrand blab-akey 2 (key (privk I)))
  (defstrand blab-akey 2 (key (privk R)))
  (deflistener (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
  (precedes ((0 6) (1 0)) ((0 6) (2 0)))
  (absent (j (exp (gen) i)) (j (exp (gen) Gr))
    (j (exp (gen) (mul Gr i))))
  (pen-non-orig (privk R) (privk I))
  (uniq-gen i j)
  (uniq-orig ci ni mi (privk R) (privk I))
  (traces
    ((send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send
        (cat I R ci cr
          (enc lst3 mi (exp (gen) j)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc algo3 mr (exp (gen) Gt)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab")) ((recv "blab") (send (privk I)))
    ((recv "blab") (send (privk R)))
    ((recv (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))
      (send (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr)))))

(defprotocol sigChild2 diffie-hellman
  (defrole init
    (vars
      (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr text)
      (Gr Gt expr) (i j expn) (R I name))
    (trace (send (cat I R ci "0" lst1 (exp (gen) i) ni))
      (recv (cat R I ci cr algo1 (exp (gen) Gr) nr))
      (send
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) i) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) Gr) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send
        (cat I R ci cr
          (enc lst3 mi (exp (gen) j)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (recv
        (cat R I ci cr
          (enc algo3 mr (exp (gen) Gt)
            (hash "KDF" ni nr (exp (gen) (mul Gr i)) ci cr))))
      (send "blab"))
    (uniq-orig ci ni mi)
    (uniq-gen i j)
    (absent (j (exp (gen) i)) (j (exp (gen) Gr))
      (j (exp (gen) (mul Gr i)))))
  (defrole resp
    (vars
      (ci cr ni nr mi mr lst1 algo1 lst2 algo2 lst3 algo3 TSi TSr text)
      (Gi Gj expr) (r t expn) (R I name))
    (trace (recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (recv
        (cat I R ci cr
          (enc lst3 mi (exp (gen) Gj)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc algo3 mr (exp (gen) t)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    (uniq-orig cr nr mr)
    (uniq-gen r t)
    (absent (r (exp (gen) Gi)) (t (exp (gen) Gi)) (t (exp (gen) r))
      (t (exp (gen) (mul Gi r))) (t (exp (gen) Gj))))
  (defrole blab-akey
    (vars (key akey))
    (trace (recv "blab") (send key))
    (uniq-orig key)))

(defskeleton sigChild2
  (vars
    (ci cr ni nr lst1 algo1 lst2 algo2 TSi TSr mi mr lst3 algo3 text)
    (R I name) (Gi expr) (r expn) (Gj expr) (t expn))
  (defstrand resp 6 (ci ci) (cr cr) (ni ni) (nr nr) (mi mi) (mr mr)
    (lst1 lst1) (algo1 algo1) (lst2 lst2) (algo2 algo2) (lst3 lst3)
    (algo3 algo3) (TSi TSi) (TSr TSr) (R R) (I I) (Gi Gi) (Gj Gj) (r r)
    (t t))
  (defstrand blab-akey 2 (key (privk I)))
  (defstrand blab-akey 2 (key (privk R)))
  (deflistener (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
  (precedes ((0 5) (1 0)) ((0 5) (2 0)))
  (absent (r (exp (gen) Gi)) (t (exp (gen) Gi)) (t (exp (gen) r))
    (t (exp (gen) (mul Gi r))) (t (exp (gen) Gj)))
  (pen-non-orig (privk R) (privk I))
  (uniq-gen r t)
  (uniq-orig cr nr mr (privk R) (privk I))
  (traces
    ((recv (cat I R ci "0" lst1 (exp (gen) Gi) ni))
      (send (cat R I ci cr algo1 (exp (gen) r) nr))
      (recv
        (cat I R ci cr
          (enc I
            (enc ci "0" lst1 (exp (gen) Gi) ni nr
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) I)
              (privk I)) lst2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc R
            (enc ci cr algo1 (exp (gen) r) nr ni
              (hash (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr) R)
              (privk R)) algo2 TSi TSr
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (recv
        (cat I R ci cr
          (enc lst3 mi (exp (gen) Gj)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))))
      (send
        (cat R I ci cr
          (enc algo3 mr (exp (gen) t)
            (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
    ((recv "blab") (send (privk I))) ((recv "blab") (send (privk R)))
    ((recv (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr))
      (send (hash "KDF" ni nr (exp (gen) (mul Gi r)) ci cr)))))
